=== debian/changelog ===
picolibc (1.7.8-1) unstable; urgency=medium

  * New upstream

  * Doc updates

  * GCC 12 fixes

  * vprintf/vscanf code size reductions

 -- Keith Packard <keithp@keithp.com>  Thu, 11 Aug 2022 08:17:37 -0700

picolibc (1.7.7-1) unstable; urgency=medium

  * New upstream

  * Merge current newlib

  * Re-do buffered I/O support

 -- Keith Packard <keithp@keithp.com>  Fri, 20 May 2022 17:46:20 -0700

picolibc (1.7.6-1) unstable; urgency=medium

  * New upstream

  * Fix use with c++ applications.

  * Fix broken compiler feature auto-detection in Debian packages.

  * Add -msave-restore for minsize RISC-V package build.

 -- Keith Packard <keithp@keithp.com>  Fri, 25 Mar 2022 14:48:45 -0700

picolibc (1.7.5-1) unstable; urgency=medium

  * New upstream

  * Fixes for bugs found with glibc test suite

  * Add '--picolibc-buildtype=release' variants for applications that
    want speed-optimized instead of space-optimized code.

 -- Keith Packard <keithp@keithp.com>  Mon, 14 Mar 2022 10:30:47 -0700
