## picolibc 1.7.9

=== meson_options.txt ===
--- 
+++ 
@@ -41,12 +41,18 @@
 option('have-format-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
        description: 'Compiler supports __format__ attribute')
 
+option('have-weak-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
+       description: 'Compiler supports __weak__ attribute')
+
 option('multilib', type: 'boolean', value: true,
        description: 'Enable multilib compile')
 
 option('multilib-list', type: 'array', value: [],
        description: 'List of multilib configurations to build for')
 
+option('build-type-subdir', type: 'string',
+       description: 'Build-type subdir. Also skips installing .specs file')
+
 option('picolib', type: 'boolean', value: true,
        description: 'Include pico lib bits')
 
@@ -62,11 +68,23 @@
 option('sysroot-install', type: 'boolean', value: false,
        description: 'Install in gcc sysroot')
 
+option('sysroot-install-skip-checks', type: 'boolean', value: false,
+       description: 'Skip sysroot path checks during config')
+
+option('system-libc', type: 'boolean', value: false,
+       description: 'Install as system C library')
+					      
 option('picoexit', type: 'boolean', value: true,
        description: 'Smaller exit/atexit/onexit code')
 
 option('fortify-source', type: 'combo', choices: ['none', '1', '2'], value: 'none',
        description: 'Set _FORTIFY_SOURCE=<value>')
+
+option('use-stdlib', type: 'boolean', value: false,
+       description: 'Do not bypass the standard system library with -nostdlib (useful for native testing)')
+
+option('profile', type: 'boolean', value: false,
+       description: 'Enable profiling by adding -pg -no-pie to compile flags')
 
 #
 # Testing options
@@ -96,6 +114,10 @@
        description: 'enable long long type support in IO functions like printf/scanf')
 option('newlib-io-long-long', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
        description: 'enable long long type support in IO functions like printf/scanf')
+option('io-pos-args', type: 'boolean', value: false,
+       description: 'enable printf-family positional arg support (always enabled for tinystdio float)')
+option('newlib-io-pos-args', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
+       description: 'enable printf-family positional arg support (always enabled for tinystdio float)')
 
 #
 # Options applying only to tinystdio
@@ -114,7 +136,7 @@
 #
 # Options applying to only legacy stdio
 #
-option('newlib-elix-level', type: 'integer', value: 2,
+option('newlib-elix-level', type: 'integer', value: 4,
        description: 'desired elix library level (0-4)')
 option('newlib-fseek-optimization', type: 'boolean', value: false,
        description: 'enable fseek optimization')
@@ -124,8 +146,6 @@
        description: 'enable global stdio streams')
 option('newlib-io-float', type: 'boolean', value: false,
        description: 'enable printf/scanf family float support')
-option('newlib-io-pos-args', type: 'boolean', value: false,
-       description: 'enable printf-family positional arg support')
 option('newlib-io-long-double', type: 'boolean', value: false,
        description: 'enable long double type support in IO functions printf/scanf (newlib stdio only)')
 option('newlib-nano-formatted-io', type: 'boolean', value: false,
@@ -157,6 +177,8 @@
        description: 'Installation directory for iconv CCS files')
 option('newlib-iconv-runtime-dir', type: 'string',
        description: 'Path used at runtime to locate iconv CCS files')
+option('newlib-iconv-encodings-exclude', type: 'array',
+       description: 'enable specific comma-separated list of bidirectional iconv encodings to be excluded')
 
 option('newlib-locale-info', type: 'boolean', value: false,
        description: 'locale support')
@@ -180,6 +202,10 @@
        description: 'compiler supports INIT_ARRAY section types')
 option('newlib-register-fini', type: 'boolean', value: false,
        description: 'enable finalization function registration using atexit')
+option('fake-semihost', type: 'boolean', value: false,
+       description: 'create fake semihost library to link tests')
+option('crt-runtime-size', type: 'boolean', value: false,
+       description: 'compute crt memory space sizes at runtime')
 
 #
 # Malloc option
@@ -204,6 +230,9 @@
        description: 'Set TLS model. No-op when thread-local-storage is false')
 option('newlib-global-errno', type: 'boolean', value: false,
        description: 'use global errno variable')
+option('errno-function', type: 'string',
+       value: 'false',
+       description: 'Use this function to compute errno address (default false, auto means autodetect)')
 
 #
 # Math options
@@ -218,19 +247,3 @@
        value: 'auto',
        description: 'Use old math code that uses float type for float valued math routines (default: automatic based on platform)')
 option('newlib-obsolete-math-double', type: 'combo', choices: ['true', 'false', 'auto'],
-       value: 'auto',
-       description: 'Use old math code for double valued math routines (default: automatic based on platform)')
-option('want-math-errno', type: 'boolean', value: false,
-       description: 'Set errno in math functions according to stdc (default: false)')
-
-#
-# Obsolete newlib options
-#
-option('newlib-long-time_t', type: 'boolean', value: false,
-       description: 'define time_t to long instead of a 64-bit type')
-option('newlib-missing-syscall-names', type: 'boolean', value: false,
-       description: 'system only provides regular syscall API')
-option('newlib-reentrant-syscalls-provided', type: 'boolean', value: false,
-       description: 'system provides reentrant syscall API')
-option('newlib-supplied-syscalls', type: 'boolean', value: false,
-       description: 'newlib supplies system call functions')
